name = "G10MM-3R"
description = "Automate gathering resources!\nVersion: 1.7"
author = "<default>"
version = "1.7"

forumthread = "https://steamcommunity.com/sharedfiles/filedetails/?id=1628298090"

api_version = 6

dont_starve_compatible = true
reign_of_giants_compatible = true
shipwrecked_compatible = true
porkland_compatible = true

icon_atlas = "modicon.xml"
icon = "modicon.tex"

configuration_options = {
	{ 
		name = "robobeestatuerecipeconfig",
		label = "G10MM-3R Base Recipe:",
		options =
		{
			{description = "Easy", hover = "1 Gears + 1 Glommer's Flower + 1 Glommer's Wings", data = 1},
			{description = "Default", hover = "2 Gears + 1 Glommer's Flower + 1 Glommer's Wings", data = 2},
			{description = "Hard", hover = "3 Gears + 1 Glommer's Flower + 1 Glommer's Wings", data = 3},
		},
		default = 2,
	},
	{ 
		name = "robobeetechconfig",
		label = "Recipe's availability:",
		options =
		{
			{description = "Obtainable", hover = "Recipe must be obtained by killing bosses or by mining Glommer's Statue.", data = 1},
			{description = "Alchemy Engine", hover = "Recipe is unlockable via Alchemy Engine.", data = 2},
			{description = "No unlock needed", hover = "Recipe is available from the start.", data = 3},
		},
		default = 1,
	},
	{ 
		name = "chesticeboxconfig",
		label = "Base Container is:",
		--hover	= "Choose the container, which should spawn.",
		options =
		{
			{description = "Chest", data = 1},
			{description = "Icebox", data = 0},
		},
		default = 1,
	},
	{ 
		name = "robobee_skin_config",
		label = "G10MM-3R skin:",
		options =
		{
			{description = "Default", hover	= "Skin based on Slime Rancher Drones.", data = 1},
			{description = "Clockwork", hover	= "Skin based on Don't Starve's clockwork monsters.", data = 2},
			{description = "Caterpillar", hover	= "Skin based on a character from \"A Bug's Life\" movie.", data = 3},
		},
		default = 1,
	},
	{ 
		name = "includestructures",
		label = "Can target structures:",
		options =
		{
			{description = "No", hover	= "G10MM-3R will ignore structures.", data = 1},
			{description = "Yes", hover	= "G10MM-3R can target Farms, Bee Boxes and Drying Racks.", data = 2},
		},
		default = 1,
	},
	{ 
		name = "includehackables",
		label = "Can hack resources:",
		options =
		{
			{description = "No", hover	= "G10MM-3R won't hack resources like Bamboo.", data = 1},
			{description = "Yes", hover	= "G10MM-3R will hack resources like Bamboo, Tall Grass, etc.", data = 2},
		},
		default = 1,
	},
	{ 
		name = "excludeitemsconfig",
		label = "Shouldn't pick up:",
		options =
		{
			{description = "None", hover = "Regular G10MM-3R pickup list.", data = 1},
			{description = "Flowers", hover = "This also includes Ferns and Succulents.", data = 2},
			{description = "Meats", hover = "This also includes Eggs and Drying Racks.", data = 3},
			{description = "Veggies/Fruits", hover = "This also includes Mushrooms and Farmplots.", data = 4},
			{description = "Seashells", hover = "Don't pick Seashell only.", data = 5},
			{description = "Flowers/Seashells", hover = "Don't pick Seashells, Flowers and Ferns.", data = 6},
			{description = "Manure", hover = "This also includes Rot and piles from Hamlet.", data = 7},
		},
		default = 1,
	},
	{ 
		name = "whentoharvest",
		label = "Harvest when target",
		options =
		{
			{description = "Is full", hover	= "G10MM-3R will harvest Bee Boxes, etc. only when they're full.", data = 1},
			{description = "Is halfway full", hover	= "G10MM-3R will harvest Bee Boxes, etc. when they're at least halfway full.", data = 2},
			{description = "Always", hover	= "G10MM-3R will harvest Bee Boxes, etc. as soon as they produce.", data = 3},
		},
		default = 1,
	},
	{ 
		name = "robobee_speed",
		label = "Move and hack speed:",
		options =
		{
			{description = "Slower", hover	= "A tiny bit slower movespeed.", data = 3},
			{description = "Default", hover	= "Regular movespeed.", data = 4},
			{description = "Faster", hover	= "G10MM-3R moves faster and hacks a bit faster.", data = 6},
			{description = "Very Fast", hover	= "G10MM-3R moves a lot faster and hacks faster.", data = 8},
		},
		default = 4,
	},
	{ 
		name = "forcerogrec",
		label = "Force RoG recipe:",
		options =
		{
			{description = "No", hover	= "Exclusive G10MM-3R recipes - SW/RoG/HAM.", data = 1},
			{description = "Yes", hover	= "G10MM-3R is only craftable with RoG ingredients.", data = 2},
		},
		default = 1,
	},
}
