local fail = true
if GLOBAL.IsDLCEnabled(GLOBAL.REIGN_OF_GIANTS) or GLOBAL.IsDLCEnabled(GLOBAL.CAPY_DLC) or GLOBAL.IsDLCEnabled(GLOBAL.PORKLAND_DLC) then
	fail = nil
end
if fail then
	print("WARNING! G10MM-3R mod will not be loaded. Ya know, compatibility reasons.")
	return false
end
--Mod doesn't load in Vanilla DS

PrefabFiles = {
	"robobee",
	"statuerobobee",
	"sparks_robobee",
}

Assets = {
	Asset("SOUNDPACKAGE", "sound/robobeesounds.fev"),
	Asset("SOUND", "sound/robobeesounds.fsb"),
	
	Asset("ATLAS", "images/inventoryimages/statuerobobee.xml"),
	Asset("IMAGE", "images/inventoryimages/statuerobobee.tex"),
	
	Asset("ATLAS", "images/inventoryimages/statuerobobee_icebox.xml"),
	Asset("IMAGE", "images/inventoryimages/statuerobobee_icebox.tex"),
	
	Asset("ATLAS", "images/map_icons/statuerobobee_map.xml"),
	Asset("IMAGE", "images/map_icons/statuerobobee_map.tex"),
	
	Asset("ATLAS", "images/map_icons/statuerobobee_map_full.xml"),
	Asset("IMAGE", "images/map_icons/statuerobobee_map_full.tex"),
	
	Asset("ATLAS", "images/map_icons/statuerobobee_map_icebox.xml"),
	Asset("IMAGE", "images/map_icons/statuerobobee_map_icebox.tex"),
	
	Asset("ATLAS", "images/map_icons/statuerobobee_map_full_icebox.xml"),
	Asset("IMAGE", "images/map_icons/statuerobobee_map_full_icebox.tex"),
	
	Asset("ATLAS", "images/map_icons/robobee.xml"),
	Asset("IMAGE", "images/map_icons/robobee.tex"),
}

if GetModConfigData("robobee_skin_config") == 2 then
	GLOBAL.ROBOBEE_SKIN = "_78"
elseif GetModConfigData("robobee_skin_config") == 3 then
	GLOBAL.ROBOBEE_SKIN = "_caterpillar"
else
	GLOBAL.ROBOBEE_SKIN = ""
end

if GLOBAL.ROBOBEE_SKIN == "_78" then
	local robobee_skin_78_assets = { 
		Asset("ATLAS", "images/inventoryimages/statuerobobee_78.xml"),
		Asset("IMAGE", "images/inventoryimages/statuerobobee_78.tex"),
	
		Asset("ATLAS", "images/inventoryimages/statuerobobee_icebox_78.xml"),
		Asset("IMAGE", "images/inventoryimages/statuerobobee_icebox_78.tex"),
	
		Asset("ATLAS", "images/map_icons/statuerobobee_map_78.xml"),
		Asset("IMAGE", "images/map_icons/statuerobobee_map_78.tex"),
	
		Asset("ATLAS", "images/map_icons/statuerobobee_map_full_78.xml"),
		Asset("IMAGE", "images/map_icons/statuerobobee_map_full_78.tex"),
	
		Asset("ATLAS", "images/map_icons/statuerobobee_map_icebox_78.xml"),
		Asset("IMAGE", "images/map_icons/statuerobobee_map_icebox_78.tex"),
	
		Asset("ATLAS", "images/map_icons/statuerobobee_map_full_icebox_78.xml"),
		Asset("IMAGE", "images/map_icons/statuerobobee_map_full_icebox_78.tex"),
	
		Asset("ATLAS", "images/map_icons/robobee_78.xml"),
		Asset("IMAGE", "images/map_icons/robobee_78.tex") }
	
	for k,v in pairs(robobee_skin_78_assets) do table.insert(Assets, v) end

elseif GLOBAL.ROBOBEE_SKIN == "_caterpillar" then
	
	local robobee_skin_caterpillar_assets = {
		Asset("ATLAS", "images/inventoryimages/statuerobobee_caterpillar.xml"),
		Asset("IMAGE", "images/inventoryimages/statuerobobee_caterpillar.tex"),
	
		Asset("ATLAS", "images/inventoryimages/statuerobobee_icebox_caterpillar.xml"),
		Asset("IMAGE", "images/inventoryimages/statuerobobee_icebox_caterpillar.tex"),
	
		Asset("ATLAS", "images/map_icons/statuerobobee_map_caterpillar.xml"),
		Asset("IMAGE", "images/map_icons/statuerobobee_map_caterpillar.tex"),
	
		Asset("ATLAS", "images/map_icons/statuerobobee_map_full_caterpillar.xml"),
		Asset("IMAGE", "images/map_icons/statuerobobee_map_full_caterpillar.tex"),
	
		Asset("ATLAS", "images/map_icons/statuerobobee_map_icebox_caterpillar.xml"),
		Asset("IMAGE", "images/map_icons/statuerobobee_map_icebox_caterpillar.tex"),
	
		Asset("ATLAS", "images/map_icons/statuerobobee_map_full_icebox_caterpillar.xml"),
		Asset("IMAGE", "images/map_icons/statuerobobee_map_full_icebox_caterpillar.tex"),
	
		Asset("ATLAS", "images/map_icons/robobee_caterpillar.xml"),
		Asset("IMAGE", "images/map_icons/robobee_caterpillar.tex") }
	
	for k,v in pairs(robobee_skin_caterpillar_assets) do table.insert(Assets, v) end
end

local require = GLOBAL.require
local STRINGS = GLOBAL.STRINGS
local RECIPETABS = GLOBAL.RECIPETABS
local Recipe = GLOBAL.Recipe
local Ingredient = GLOBAL.Ingredient
local TECH = GLOBAL.TECH
local TUNING = GLOBAL.TUNING
local ACTIONS = GLOBAL.ACTIONS
local ActionHandler = GLOBAL.ActionHandler

GLOBAL.ROBOBEE_HARVEST = GetModConfigData("whentoharvest")

if GetModConfigData("chesticeboxconfig") == 1 then
	GLOBAL.STATUEROBOBEE_CONTAINER = "chest"
else
	GLOBAL.STATUEROBOBEE_CONTAINER = "icebox"
end

if GetModConfigData("includestructures") == 2 then
	GLOBAL.STATUEROBOBEE_EXCLUDETAGS = {"robobee_target", "locomotor", "robobee_excluded", "withered", "dungball", "dungpile"}
	GLOBAL.STATUEROBOBEE_INCLUDETAGS = {"pickable", "robobee_transportable", "readyforharvest", "dried"}
else
	GLOBAL.STATUEROBOBEE_EXCLUDETAGS = {"robobee_target", "structure", "locomotor", "robobee_excluded", "withered", "dungball", "dungpile"}
	GLOBAL.STATUEROBOBEE_INCLUDETAGS = {"pickable", "robobee_transportable"}
end

if GetModConfigData("includehackables") == 1 and (GLOBAL.IsDLCEnabled(GLOBAL.CAPY_DLC) or GLOBAL.IsDLCEnabled(GLOBAL.PORKLAND_DLC)) then
	GLOBAL.ROBOBEE_CAN_HACK = false
else
	GLOBAL.ROBOBEE_CAN_HACK = true
	
	local hackables_includetag = "hackable"
	local hackables_excludetag = "stump"
	table.insert(GLOBAL.STATUEROBOBEE_INCLUDETAGS, hackables_includetag)
	table.insert(GLOBAL.STATUEROBOBEE_EXCLUDETAGS, hackables_excludetag)
end

GLOBAL.ROBOBEE_MOVESPEED = GetModConfigData("robobee_speed")

local numgears = GetModConfigData("robobeestatuerecipeconfig")

local imageatlas = nil
if GetModConfigData("chesticeboxconfig") == 1 then
	imageatlas = "statuerobobee"
else
	imageatlas = "statuerobobee_icebox"
end

if GetModConfigData("robobeetechconfig") == 1 then
	GLOBAL.ROBOBEE_TECH = {LOST = 2}
elseif GetModConfigData("robobeetechconfig") == 2 then
	GLOBAL.ROBOBEE_TECH = {SCIENCE = 2}
else
	GLOBAL.ROBOBEE_TECH = {NONE = 1}
end

local robobee_rec_rog_forced = GetModConfigData("forcerogrec")

if robobee_rec_rog_forced == 2 then

	local statuerec = GLOBAL.Recipe("statuerobobee", { Ingredient("gears", numgears), Ingredient("glommerflower", 1), Ingredient("glommerwings", 1)}, RECIPETABS.SCIENCE, GLOBAL.ROBOBEE_TECH, GLOBAL.RECIPE_GAME_TYPE.COMMON)
	statuerec.atlas = "images/inventoryimages/" .. imageatlas .. ".xml"
	statuerec.image = "statuerobobee" .. GLOBAL.ROBOBEE_SKIN .. ".tex"
	statuerec.placer = "statuerobobee_placer"
	statuerec.min_spacing = 1.5
	statuerec.sortkey = -99
	
else

	local statuerec = GLOBAL.Recipe("statuerobobee", { Ingredient("gears", numgears), Ingredient("glommerflower", 1), Ingredient("glommerwings", 1)}, RECIPETABS.SCIENCE, GLOBAL.ROBOBEE_TECH, GLOBAL.RECIPE_GAME_TYPE.ROG)
	statuerec.atlas = "images/inventoryimages/" .. imageatlas .. ".xml"
	statuerec.image = "statuerobobee" .. GLOBAL.ROBOBEE_SKIN .. ".tex"
	statuerec.placer = "statuerobobee_placer"
	statuerec.min_spacing = 1.5
	statuerec.sortkey = -99

	local statuerec1 = GLOBAL.Recipe("statuerobobee", { Ingredient("gears", (math.ceil(numgears*1.5))), Ingredient("coral_brain", 1), Ingredient("dug_elephantcactus", 1)}, RECIPETABS.SCIENCE, GLOBAL.ROBOBEE_TECH, GLOBAL.RECIPE_GAME_TYPE.SHIPWRECKED)
	statuerec1.atlas = "images/inventoryimages/" .. imageatlas .. ".xml"
	statuerec1.image = "statuerobobee" .. GLOBAL.ROBOBEE_SKIN .. ".tex"
	statuerec1.placer = "statuerobobee_placer"
	statuerec1.min_spacing = 1.5
	statuerec1.sortkey = -99

	local statuerec2 = GLOBAL.Recipe("statuerobobee", { Ingredient("gears", 1), Ingredient("lotus_flower", 1), Ingredient("livinglog", numgears)}, RECIPETABS.SCIENCE, GLOBAL.ROBOBEE_TECH, GLOBAL.RECIPE_GAME_TYPE.PORKLAND)
	statuerec2.atlas = "images/inventoryimages/" .. imageatlas .. ".xml"
	statuerec2.image = "statuerobobee" .. GLOBAL.ROBOBEE_SKIN .. ".tex"
	statuerec2.placer = "statuerobobee_placer"
	statuerec2.min_spacing = 1.5
	statuerec2.sortkey = -99
end

if GLOBAL.ROBOBEE_SKIN == "_78" then
	AddMinimapAtlas("images/map_icons/statuerobobee_map_78.xml")
	AddMinimapAtlas("images/map_icons/statuerobobee_map_full_78.xml")
	AddMinimapAtlas("images/map_icons/statuerobobee_map_icebox_78.xml")
	AddMinimapAtlas("images/map_icons/statuerobobee_map_full_icebox_78.xml")
	AddMinimapAtlas("images/map_icons/robobee_78.xml")
	
elseif GLOBAL.ROBOBEE_SKIN == "_caterpillar" then
	AddMinimapAtlas("images/map_icons/statuerobobee_map_caterpillar.xml")
	AddMinimapAtlas("images/map_icons/statuerobobee_map_full_caterpillar.xml")
	AddMinimapAtlas("images/map_icons/statuerobobee_map_icebox_caterpillar.xml")
	AddMinimapAtlas("images/map_icons/statuerobobee_map_full_icebox_caterpillar.xml")
	AddMinimapAtlas("images/map_icons/robobee_caterpillar.xml")
	
else
	AddMinimapAtlas("images/map_icons/statuerobobee_map.xml")
	AddMinimapAtlas("images/map_icons/statuerobobee_map_full.xml")
	AddMinimapAtlas("images/map_icons/statuerobobee_map_icebox.xml")
	AddMinimapAtlas("images/map_icons/statuerobobee_map_full_icebox.xml")
	AddMinimapAtlas("images/map_icons/robobee.xml")
end

if GLOBAL.IsDLCEnabled(GLOBAL.PORKLAND_DLC) then
	local pigguard_hammerhandler = ActionHandler(ACTIONS.HAMMER, "chop") -- this lets pig guards hammer stuff
	AddStategraphActionHandler("pig", pigguard_hammerhandler)
	
	function PigGuardianPostInit(inst)
		inst:ListenForEvent("attacked", function(inst, data)
			if data.attacker and data.attacker:HasTag("robobee") then
			
				if data.attacker and data.attacker.components.homeseeker and data.attacker.components.homeseeker:HasHome() then
					inst.target_statuerobobee = data.attacker.components.homeseeker.home
					local brain = require "brains/pigguarddestructorbrain"
					inst:SetBrain(brain)
				end
				
			end
		end)
		
		inst:ListenForEvent("finishedwork", function(inst, data)
			if data.target and data.target:HasTag("statuerobobee") then
			
				inst.target_statuerobobee = nil
				local brain = require "brains/royalpigguardbrain"
				inst:SetBrain(brain)
				
			end
		end)
		
		inst:DoPeriodicTask(5, function()
			if inst.target_statuerobobee ~= nil and (not inst.target_statuerobobee:IsValid() or inst.target_statuerobobee:IsInLimbo()) then
				inst.target_statuerobobee = nil
				local brain = require "brains/royalpigguardbrain"
				inst:SetBrain(brain)
			end
		end)
	end 
	AddPrefabPostInit("pigman_royalguard", PigGuardianPostInit)
	AddPrefabPostInit("pigman_royalguard_2", PigGuardianPostInit)
end

AddComponentPostInit("pickable", function(Pickable)
	local OldPick = Pickable.Pick
	Pickable.Pick = function(self, picker, ...)
		if self.inst and picker ~= nil and not picker:HasTag("robobee") and self.inst.robobee_picker ~= nil then
			self.inst.robobee_picker.pickable_target = nil
			self.inst.robobee_picker:PushEvent("robobee_targetstolen")
			self.inst.robobee_picker = picker
		end
		
		local inst = self.inst
		self.inst:DoTaskInTime(2, function(inst) 
			if inst and inst.components.pickable and inst.components.pickable:CanBePicked() and self.inst.robobee_picker ~= nil then
				if self.inst.robobee_picker.bufferedaction ~= nil and self.inst.robobee_picker.bufferedaction.action == ACTIONS.PICK and self.inst.robobee_picker.bufferedaction.target == self.inst then
					-- check for 2 cases: IF player has picked the object earlier OR Wickerbottom is mass farming resources
					-- if yes, then clear robobee_picker
				else
					self.inst.robobee_picker = nil
				end
			end
		end) -- crappy hacky way to prevent bee targeting bug
		
		if self.inst and self.inst:IsValid() and self.inst:HasTag("pickable") then
			self.inst:RemoveTag("pickable")
		end
		
		OldPick(self, picker, ...)
	end
end)

AddComponentPostInit("pickable", function(Pickable)
	local OldRegen = Pickable.Regen
	Pickable.Regen = function(self, ...)
	
		if self.inst and self.inst:IsValid() then
			if self.inst:HasTag("robobee_target") then
				self.inst:RemoveTag("robobee_target")
			end
			if self.inst.robobee_picker ~= nil then
				self.inst.robobee_picker = nil
			end
			
			if self.inst and not self.inst:HasTag("pickable") then
				self.inst:AddTag("pickable")
			end
		end
		
		OldRegen(self, ...)
	end
end)

AddComponentPostInit("pickable", function(Pickable)
	local OldSetUp = Pickable.SetUp
	Pickable.SetUp = function(self, product, regen, number, ...)
	
		if self.inst and self.inst:IsValid() and not self.inst:HasTag("pickable") then
			self.inst:DoTaskInTime(1, function() 
				if self.inst and self.inst:IsValid() and self.inst.components.pickable and self.inst.components.pickable:CanBePicked() and self.caninteractwith == true and not self.inst:HasTag("pickable") then
					self.inst:AddTag("pickable")
				end
			end)
		end
		
		OldSetUp(self, product, regen, number, ...)
	end
end)

AddComponentPostInit("pickable", function(Pickable)
	local OldMakeEmpty = Pickable.MakeEmpty
	Pickable.MakeEmpty = function(self, ...)
	
		if self.inst and self.inst:IsValid() and self.inst:HasTag("pickable") then
			self.inst:RemoveTag("pickable")
		end
		
		OldMakeEmpty(self, ...)
	end
end)

AddComponentPostInit("pickable", function(Pickable)
	local OldMakeBarren = Pickable.MakeBarren
	Pickable.MakeBarren = function(self, ...)
	
		if self.inst and self.inst:IsValid() and self.inst:HasTag("pickable") then
			self.inst:RemoveTag("pickable")
		end
		
		OldMakeBarren(self, ...)
	end
end)

if (GLOBAL.IsDLCEnabled(GLOBAL.CAPY_DLC) or GLOBAL.IsDLCEnabled(GLOBAL.PORKLAND_DLC)) and GLOBAL.ROBOBEE_CAN_HACK == true then
	AddComponentPostInit("hackable", function(Hackable)
		local OldSetUp = Hackable.SetUp
		Hackable.SetUp = function(self, product, regen, number, ...)
	
			if self.inst and self.inst:IsValid() and not self.inst:HasTag("hackable") then
				self.inst:AddTag("hackable")
			end
		
			OldSetUp(self, product, regen, number, ...)
		end
	end)

	AddComponentPostInit("hackable", function(Hackable)
		local OldHack = Hackable.Hack
		Hackable.Hack = function(self, hacker, numworks, ...)
			if self.inst and hacker ~= nil and not hacker:HasTag("robobee") and self.inst.robobee_picker ~= nil then
				self.inst.robobee_picker.hacktarget = nil
				self.inst.robobee_picker:PushEvent("robobee_targetstolen")
				self.inst.robobee_picker = hacker
			end
			
			if hacker and hacker:HasTag("robobee") and numworks then
				if GLOBAL.ROBOBEE_MOVESPEED == 6 then
					numworks = numworks+0.5
				elseif GLOBAL.ROBOBEE_MOVESPEED == 8 then
					numworks = numworks+1
				end
			end
		
			OldHack(self, hacker, numworks, ...)
		end
	end)
end

AddComponentPostInit("harvestable", function(Harvestable)
	local OldStartGrowing = Harvestable.StartGrowing
	Harvestable.StartGrowing = function(self, time, ...)
	
		if self.inst and self.inst:IsValid() and self.inst:HasTag("readyforharvest") and not self:CanBeHarvested() then
			self.inst:RemoveTag("readyforharvest")
		elseif self.inst and self.inst:IsValid() and not self.inst:HasTag("readyforharvest") and self:CanBeHarvested() then
			self.inst:AddTag("readyforharvest")
		end
		
		OldStartGrowing(self, time, ...)
	end
end)

AddComponentPostInit("harvestable", function(Harvestable)
	local OldHarvest = Harvestable.Harvest
	Harvestable.Harvest = function(self, picker, ...)
	
		if self.inst and self.inst:IsValid() and self.inst:HasTag("readyforharvest") then
			self.inst:RemoveTag("readyforharvest")
		end
		
		return OldHarvest(self, picker, ...)
	end
end)

AddComponentPostInit("harvestable", function(Harvestable)
	local OldSetUp = Harvestable.SetUp
	Harvestable.SetUp = function(self, product, max, time, onharvest, ongrow, ...)
	
		if self.inst and self.inst:IsValid() and not self.inst:HasTag("readyforharvest") then
			self.inst:DoTaskInTime(1, function()
				if self.inst and self.inst:IsValid() and not self.inst:HasTag("readyforharvest") and self.inst.components.harvestable and self.inst.components.harvestable:CanBeHarvested() then
					self.inst:AddTag("readyforharvest")
				end
			end)
		end
		
		OldSetUp(self, product, max, time, onharvest, ongrow, ...)
	end
end)

AddComponentPostInit("crop", function(Crop)
	local OldMature = Crop.Mature
	Crop.Mature = function(self, ...)
	
		if self.inst and self.inst:IsValid() and not self.inst:HasTag("readyforharvest") then
			self.inst:AddTag("readyforharvest")
		end
		
		OldMature(self, ...)
	end
end)

AddComponentPostInit("dryer", function(Dryer)
	local OldStopDrying = Dryer.StopDrying
	Dryer.StopDrying = function(self, reason, ...)
	
		if self.inst and self.inst:IsValid() and not self.inst:HasTag("dried") then
			self.inst:AddTag("dried")
		end
		
		OldStopDrying(self, reason, ...)
	end
end)

AddComponentPostInit("dryer", function(Dryer)
	local OldIsDone = Dryer.IsDone
	Dryer.IsDone = function(self, ...)
	
		if self.inst and self.inst:IsValid() and not self.inst:HasTag("dried") and self.product and self.targettime and self:GetTimeToDry() < 0 then
			self.inst:AddTag("dried")
		elseif self.inst and self.inst:IsValid() and self.inst:HasTag("dried") and (not self.product or not self.targettime or self:GetTimeToDry() > 0) then
			self.inst:RemoveTag("dried")
		end
		
		return OldIsDone(self, ...)
	end
end)

AddComponentPostInit("dryer", function(Dryer)
	local OldHarvest = Dryer.Harvest
	Dryer.Harvest = function(self, harvester, ...)
	
		if self.inst and self.inst:IsValid() and self.inst:HasTag("dried") then
			self.inst:RemoveTag("dried")
		end
		
		return OldHarvest(self, harvester, ...)
	end
end)

AddComponentPostInit("inventoryitem", function(Inventoryitem)
	local OldOnPutInInventory = Inventoryitem.OnPutInInventory
	Inventoryitem.OnPutInInventory = function(self, owner, ...)
	
		if self.inst.robobee_picker ~= nil then
			if self.inst.robobee_picker.pickable_target ~= nil then
				self.inst.robobee_picker.pickable_target = nil
			end
			self.inst.robobee_picker = nil
		end
		
		if self.inst.stackbreaker ~= nil then
			if self.inst.stackbreaker.stacktobreak ~= nil then
				self.inst.stackbreaker.stacktobreak = nil
				if self.inst.stackbreaker.bufferedaction ~= nil and self.inst.stackbreaker.bufferedaction == ACTIONS.BREAKSTACK and self.inst.stackbreaker.bufferedaction.target == self.inst then
					self.inst.stackbreaker:ClearBufferedAction()
				end
			end
			self.inst.stackbreaker = nil
		end
		
		if self.inst:HasTag("robobee_target") then
			self.inst:RemoveTag("robobee_target")
		end
		
		OldOnPutInInventory(self, owner, ...)
	end
end)

AddComponentPostInit("inventoryitem", function(Inventoryitem)
	local OldOnDropped = Inventoryitem.OnDropped
	Inventoryitem.OnDropped = function(self, randomdir, speedmult, ...)
	
		if self.inst.wasmadeclear ~= nil and self.inst.wasmadeclear == true and self.inst.AnimState then
			self.inst.AnimState:SetMultColour(1, 1, 1, 1)
			self.inst.wasmadeclear = nil
		end
		
		OldOnDropped(self, randomdir, speedmult, ...)
	end
end)

AddComponentPostInit("spellcaster", function(SpellCaster)
	local OldCanCast = SpellCaster.CanCast
	SpellCaster.CanCast = function(self, doer, target, pos, ...)
	
		if target ~= nil and target:HasTag("robobee") then
			-- Keep that dirty magic away from my pure bee!
			return false
		else
			return OldCanCast(self, doer, target, pos, ...)
		end

	end
end)

AddComponentPostInit("childspawner", function(ChildSpawner)
	local OldReleaseAllChildren = ChildSpawner.ReleaseAllChildren
	ChildSpawner.ReleaseAllChildren = function(self, target, prefab, ...)
	
	-- Don't release children if robobee is the target
	-- Yes, I had to edit the component, because beebox is not very mod-friendly
		if target == nil or target ~= nil and not target:HasTag("robobee") then
			OldReleaseAllChildren(self, target, prefab, ...)
		end

	end
end)

function RobobeePickableItems(inst)
    inst:AddTag("robobee_transportable")
end

if GetModConfigData("excludeitemsconfig") ~= 4 then
	local plants_shrooms =
		{"berries", 
		"berries_juicy", 
		"carrot", 
		"cactus_meat", 
		"watermelon", 
		"dragonfruit", 
		"pomegranate", 
		"durian", 
		"eggplant",
		"pumpkin",
		"cave_banana",
		"cactus_flower",
		"seeds",
		"red_cap",
		"green_cap",
		"blue_cap",
		"petals",
		"petals_evil",
		"foliage",
		"lightbulb",}
	for k,v in pairs(plants_shrooms) do AddPrefabPostInit(v, RobobeePickableItems) end
	
	if GLOBAL.IsDLCEnabled(GLOBAL.CAPY_DLC) or GLOBAL.IsDLCEnabled(GLOBAL.PORKLAND_DLC) then
		local shipwrecked_veggies =
		{"coconut",
		"coconut_halved",
		"cutlichen",
		"coffeebeans",
		"sweet_potato",
		"seaweed"}
		for k,v in pairs(shipwrecked_veggies) do AddPrefabPostInit(v, RobobeePickableItems) end
	end
	
	if GLOBAL.IsDLCEnabled(GLOBAL.PORKLAND_DLC) then
		local hamlet_veggies =
		{"lotus_flower",
		"tuber_crop",
		"teatree_nut",
		"cutnettle",
		"radish",
		"asparagus",
		"aloe",
		"clippings",
		"tuber_bloom_crop"}
		for k,v in pairs(hamlet_veggies) do AddPrefabPostInit(v, RobobeePickableItems) end
	end
end
	
if GetModConfigData("excludeitemsconfig") ~= 3 then
	local meats_eggs =
		{"meat",
		"monstermeat",
		"monstermeat_dried",
		"meat_dried",
		"smallmeat_dried",
		"smallmeat",
		"drumstick",
		"batwing",
		"plantmeat",
		"fish",
		"eel",
		"bird_egg",
		"tallbirdegg",
		"froglegs",}
	for k,v in pairs(meats_eggs) do AddPrefabPostInit(v, RobobeePickableItems) end
	
	if GLOBAL.IsDLCEnabled(GLOBAL.CAPY_DLC) or GLOBAL.IsDLCEnabled(GLOBAL.PORKLAND_DLC) then
		local shipwrecked_meats =
		{"blubber",
		"tropical_fish",
		"fish_raw_small",
		"dead_swordfish",
		"fish_med",
		"jellyfish_dead",
		"limpets",
		"mussel",
		"fish2",
		"fish3",
		"fish4",
		"fish5",
		"fish_raw",
		"roe",
		"shark_fin",
		"lobster_dead",
		"jellyjerky",
		"dragoonheart"}
		for k,v in pairs(shipwrecked_meats) do AddPrefabPostInit(v, RobobeePickableItems) end
	end
	
	if GLOBAL.IsDLCEnabled(GLOBAL.PORKLAND_DLC) then
		local hamlet_meats =
		{"jellybug",
		"slugbug",
		"froglegs_poison"}
		for k,v in pairs(hamlet_meats) do AddPrefabPostInit(v, RobobeePickableItems) end
	end
end

if GetModConfigData("excludeitemsconfig") ~= 7 then
	local manure =
		{"poop",
		"guano",
		"spoiled_food",
		"glommerfuel",}
	for k,v in pairs(manure) do AddPrefabPostInit(v, RobobeePickableItems) end
end
	
local resources =
	{"cutreeds",
	"cutgrass",
	"twigs",
	"manrabbit_tail",
	"pigskin",
	"rocks",
	"flint",
	"goldnugget",
	"nitre",
	"marble",
	"log",
	"pinecone",
	"acorn",
	"spidergland",
	"silk",}
for k,v in pairs(resources) do AddPrefabPostInit(v, RobobeePickableItems) end
	
local other =
	{"charcoal",
	"honey",
	"ash",
	"butterflywings",
	"beardhair",
	"goatmilk",
	"stinger",
	"slurper_pelt",
	"houndstooth",
	"beefalowool"}
for k,v in pairs(other) do AddPrefabPostInit(v, RobobeePickableItems) end

if GLOBAL.IsDLCEnabled(GLOBAL.CAPY_DLC) or GLOBAL.IsDLCEnabled(GLOBAL.PORKLAND_DLC) then
	local shipwrecked_items =
	{"coral",
	"boneshard",
	"palmleaf",
	"sand",
	"venomgland",
	"hail_ice",
	"tar",
	"snakeskin",
	"vine",
	"bamboo",
	"limestone",
	"snakeoil",
	"dubloon",
	"seashell",
	}
	for k,v in pairs(shipwrecked_items) do AddPrefabPostInit(v, RobobeePickableItems) end
end

if GLOBAL.IsDLCEnabled(GLOBAL.PORKLAND_DLC) then
	local hamlet_items =
	{"cork",
	"chitin",
	"bat_hide",
	"burr",
	"oinc",
	"oinc10",
	"oinc100",
	"peagawkfeather",
	"iron",
	"snake_bone"
	}
	for k,v in pairs(hamlet_items) do AddPrefabPostInit(v, RobobeePickableItems) end
end
	
---

function RobobeeExcludedItems(inst)
    inst:AddTag("robobee_excluded")
end

if GetModConfigData("excludeitemsconfig") == 2 then
	local flowers =
		{"flower",
		"flower_evil",
		"cave_fern",}
	for k,v in pairs(flowers) do AddPrefabPostInit(v, RobobeeExcludedItems) end
end

if GetModConfigData("excludeitemsconfig") == 3 then
	AddPrefabPostInit("meatrack", RobobeeExcludedItems)
end

if GetModConfigData("excludeitemsconfig") == 4 then
	AddPrefabPostInit("plant_normal", RobobeeExcludedItems)
end

if GLOBAL.IsDLCEnabled(GLOBAL.CAPY_DLC) or GLOBAL.IsDLCEnabled(GLOBAL.PORKLAND_DLC) then
	if GetModConfigData("excludeitemsconfig") == 5 then
		AddPrefabPostInit("seashell_beached", RobobeeExcludedItems)
		AddPrefabPostInit("seashell", RobobeeExcludedItems)
	end

	if GetModConfigData("excludeitemsconfig") == 6 then
		local flowersandseashells =
			{"flower",
			"flower_evil",
			"cave_fern",
			"seashell_beached",
			"seashell",}
		for k,v in pairs(flowersandseashells) do AddPrefabPostInit(v, RobobeeExcludedItems) end
	end
else
	if GetModConfigData("excludeitemsconfig") == 6 then
		local flowers =
			{"flower",
			"flower_evil",
			"cave_fern",}
		for k,v in pairs(flowers) do AddPrefabPostInit(v, RobobeeExcludedItems) end
	end
end

---

function GlommerStatuePostInit(inst)
	-- jeez, I hate how freaking backwards-coded singleplayer DS is...
	inst:ListenForEvent("workfinished", function()
		local shouldspawnblueprint = true
		local player_recipes = GLOBAL.GetPlayer() and GLOBAL.GetPlayer().components.builder and GLOBAL.GetPlayer().components.builder.recipes or nil
	
		if player_recipes ~= nil then
			for k,v in pairs(player_recipes) do
				if v and type(v) == "string" and v == "statuerobobee" then
					shouldspawnblueprint = false
				end
			end
		end
		
		if shouldspawnblueprint == true then
			local pt = Point(inst.Transform:GetWorldPosition())
			local loot = GLOBAL.SpawnPrefab("statuerobobee_blueprint")
			
			if loot then
				loot.Transform:SetPosition(pt.x,pt.y,pt.z)
				loot.components.inventoryitem:OnDropped(true)
			end
		end
	end)
end 
AddPrefabPostInit("statueglommer", GlommerStatuePostInit)

if GLOBAL.IsDLCEnabled(GLOBAL.CAPY_DLC) or GLOBAL.IsDLCEnabled(GLOBAL.PORKLAND_DLC) then

function BlueprintDropsPostInit(inst)
	inst:ListenForEvent("death", function()
		local shouldspawnblueprint = true
	
		local player_recipes = GLOBAL.GetPlayer() and GLOBAL.GetPlayer().components.builder and GLOBAL.GetPlayer().components.builder.recipes or nil
	
		if player_recipes ~= nil then
			for k,v in pairs(player_recipes) do
				if v and type(v) == "string" and v == "statuerobobee" then
					shouldspawnblueprint = false
				end
			end
		end
		
		if shouldspawnblueprint == true then
			local pt = Point(inst.Transform:GetWorldPosition())
			local loot = GLOBAL.SpawnPrefab("statuerobobee_blueprint")
			
			if inst and inst.prefab == "twister" then
				inst:DoTaskInTime(0.35, function()
					if loot then
						loot.Transform:SetPosition(pt.x,5,pt.z)
						loot.components.inventoryitem:OnDropped(true)
					end
				end)
			else
				if loot then
					loot.Transform:SetPosition(pt.x,pt.y,pt.z)
					loot.components.inventoryitem:OnDropped(true)
				end
			end
		end
	end)
end 
AddPrefabPostInit("kraken", BlueprintDropsPostInit)
AddPrefabPostInit("twister", BlueprintDropsPostInit)
AddPrefabPostInit("tigershark", BlueprintDropsPostInit)

function SnakeDenPostInit(inst)
	if inst and inst.components.hackable and inst.components.hackable.onhackedfn ~= nil then
		local OldOnHackedFn = inst.components.hackable.onhackedfn
		
		local function NewOnHackedFn(inst, hacker, hacksleft)
			if hacker and hacker:HasTag("robobee") then
				local fx = GLOBAL.SpawnPrefab("hacking_fx")
				local x, y, z= inst.Transform:GetWorldPosition()
				fx.Transform:SetPosition(x,y + math.random()*2,z)

				if(hacksleft <= 0) then

					inst.AnimState:PlayAnimation("disappear")

					if inst.components.hackable and inst.components.hackable:IsBarren() then
						inst.AnimState:PushAnimation("idle_dead")
						inst.Physics:SetCollides(true)
					else
						inst.Physics:SetCollides(false)
						inst.SoundEmitter:PlaySound("dontstarve_DLC002/common/vine_drop")
						inst.AnimState:PushAnimation("hacked_idle")
					end
				else
					inst.SoundEmitter:PlaySound("dontstarve_DLC002/common/vine_hack")
					inst.AnimState:PlayAnimation("chop")
					inst.AnimState:PushAnimation("idle")
				end
			else
				OldOnHackedFn(inst, hacker, hacksleft)
			end
		end
		
		inst.components.hackable.onhackedfn = NewOnHackedFn
	end
	
	if inst and inst.components.playerprox and inst.components.playerprox.onnear ~= nil then
		local OldOnNear = inst.components.playerprox.onnear
		
		local function NewOnNear(inst)
			if inst.components.hackable:CanBeHacked() then
				OldOnNear(inst)
			end
		end
		
		inst.components.playerprox:SetOnPlayerNear(NewOnNear)
	end
end 
AddPrefabPostInit("snakeden", SnakeDenPostInit)

end

if GLOBAL.IsDLCEnabled(GLOBAL.PORKLAND_DLC) then

function BlueprintHamDropsPostInit(inst)
	inst:ListenForEvent("death", function()
		local shouldspawnblueprint = true
	
		local player_recipes = GLOBAL.GetPlayer() and GLOBAL.GetPlayer().components.builder and GLOBAL.GetPlayer().components.builder.recipes or nil
	
		if player_recipes ~= nil then
			for k,v in pairs(player_recipes) do
				if v and type(v) == "string" and v == "statuerobobee" then
					shouldspawnblueprint = false
				end
			end
		end
		
		if shouldspawnblueprint == true then
			local pt = Point(inst.Transform:GetWorldPosition())
			local loot = GLOBAL.SpawnPrefab("statuerobobee_blueprint")
			
			if loot then
				loot.Transform:SetPosition(pt.x+1,pt.y,pt.z)
				loot.components.inventoryitem:OnDropped(true)
			end
		end
	end)
end 
AddPrefabPostInit("antqueen", BlueprintHamDropsPostInit)

function BlueprintHamPoopPostInit(inst)
	inst:ListenForEvent("picked", function()
		local shouldspawnblueprint = true
	
		local player_recipes = GLOBAL.GetPlayer() and GLOBAL.GetPlayer().components.builder and GLOBAL.GetPlayer().components.builder.recipes or nil
	
		if player_recipes ~= nil then
			for k,v in pairs(player_recipes) do
				if v and type(v) == "string" and v == "statuerobobee" then
					shouldspawnblueprint = false
				end
			end
		end
		
		if shouldspawnblueprint == true and math.random(1, 100) > 99 then
			local pt = Point(inst.Transform:GetWorldPosition())
			local loot = GLOBAL.SpawnPrefab("statuerobobee_blueprint")
			
			if loot then
				loot.Transform:SetPosition(pt.x,1,pt.z)
				loot.components.inventoryitem:OnDropped(true)
			end
		end
	end)
end 
AddPrefabPostInit("dungball", BlueprintHamPoopPostInit)

end

function ShroomsPostInit(inst)
	inst:DoPeriodicTask(2, function()
		if inst.components.pickable and inst.components.pickable:CanBePicked() and inst.components.pickable.caninteractwith == true and not inst:HasTag("pickable") then
			inst:AddTag("pickable")
		else
			if inst:HasTag("pickable") then
				inst:RemoveTag("pickable")
			end
		end
	end)
end 
local shrooms = {"blue_mushroom", "green_mushroom", "red_mushroom"}
for k,v in pairs(shrooms) do AddPrefabPostInit(v, ShroomsPostInit) end

local BREAKSTACK = GLOBAL.Action({ priority= 10 })	
BREAKSTACK.str = "Break Stack"
BREAKSTACK.id = "BREAKSTACK"
BREAKSTACK.fn = function(act)
	if act.target ~= nil and
	   act.doer and
	   act.doer:HasTag("robobee") and
       act.target.components.inventoryitem ~= nil and
	   not act.target.components.inventoryitem:IsHeld() and
	   act.target.components.stackable ~= nil and
	   act.target.components.stackable:IsStack() then
		local target = act.target
        return act.doer.components.stackbreaker:BreakStack(target)
	end
end
AddAction(BREAKSTACK)

STRINGS.NAMES.ROBOBEE = "G10MM-3R"

STRINGS.CHARACTERS.GENERIC.DESCRIBE.ROBOBEE = "It's buzzing with electricity."
STRINGS.CHARACTERS.WILLOW.DESCRIBE.ROBOBEE = "It's not as fuzzy as the real thing..."
STRINGS.CHARACTERS.WENDY.DESCRIBE.ROBOBEE = "The original is dead. This one is just a mindless drone..."
STRINGS.CHARACTERS.WOLFGANG.DESCRIBE.ROBOBEE = "Is robot bug tiny robot person's friend?"
STRINGS.CHARACTERS.WX78.DESCRIBE.ROBOBEE = "MAYBE IT HAS A SIMPLE BRAIN, BUT IT'S NOT A BRAIN MADE OF FLESH"
STRINGS.CHARACTERS.WICKERBOTTOM.DESCRIBE.ROBOBEE = "An artificial creature with seemingly infinite energy."
STRINGS.CHARACTERS.WOODIE.DESCRIBE.ROBOBEE = "Whatever I chop, it'll collect, eh?"
STRINGS.CHARACTERS.WAXWELL.DESCRIBE.ROBOBEE = "Well, at least this one doesn't leave its feces everywhere."
STRINGS.CHARACTERS.WATHGRITHR.DESCRIBE.ROBOBEE = "Majestic goober, in a majestic armor."
STRINGS.CHARACTERS.WEBBER.DESCRIBE.ROBOBEE = "Always busy! He has no time for fun."

STRINGS.NAMES.STATUEROBOBEE = "G10MM-3R Base"
STRINGS.RECIPE_DESC.STATUEROBOBEE = "Small deposit station. Comes with a drone."

STRINGS.CHARACTERS.GENERIC.DESCRIBE.STATUEROBOBEE_BLUEPRINT = "This blueprint looks quite complex."

STRINGS.CHARACTERS.GENERIC.DESCRIBE.STATUEROBOBEE = { 
	GENERIC = "It's an electric plant. I named it a \"power-plant\".", 
	BEEINSIDE = "Scientifically speaking, sleeping does \"charge your batteries\"." }
	
STRINGS.CHARACTERS.WILLOW.DESCRIBE.STATUEROBOBEE = { 
	GENERIC = "I mean... At least it's useful...", 
	BEEINSIDE = "It's actually sleeping or is it just trying to mock me?" }

STRINGS.CHARACTERS.WENDY.DESCRIBE.STATUEROBOBEE = { 
	GENERIC = "It provides that hollow drone a place to rest.", 
	BEEINSIDE = "One day it's going to die from an electrical outage." }
	
STRINGS.CHARACTERS.WOLFGANG.DESCRIBE.STATUEROBOBEE = { 
	GENERIC = "Hah, dumb machine. You are not flower.", 
	BEEINSIDE = "Flower is cozy bed for robot." }
	
STRINGS.CHARACTERS.WX78.DESCRIBE.STATUEROBOBEE = { 
	GENERIC = "I APPRECIATE ITS NON-ORGANIC PARTS", 
	BEEINSIDE = "SLEEP WELL, FRIEND" }

STRINGS.CHARACTERS.WICKERBOTTOM.DESCRIBE.STATUEROBOBEE = { 
	GENERIC = "A structure utilizing conductivity of flora.", 
	BEEINSIDE = "This automated creature is able to imitate the act of sleeping." }
	
STRINGS.CHARACTERS.WOODIE.DESCRIBE.STATUEROBOBEE = { 
	GENERIC = "That thing is made of metal, even if it doesn't look like it.", 
	BEEINSIDE = "So it comes here for a nap, eh?" }

STRINGS.CHARACTERS.WAXWELL.DESCRIBE.STATUEROBOBEE = { 
	GENERIC = "This flower may be pretty, but its smell... not so much.", 
	BEEINSIDE = "It's resting after a long day of physical labor." }
	
STRINGS.CHARACTERS.WATHGRITHR.DESCRIBE.STATUEROBOBEE = { 
	GENERIC = "This automaton station grants infinite power!", 
	BEEINSIDE = "Goober is resting after a battle." }
	
STRINGS.CHARACTERS.WEBBER.DESCRIBE.STATUEROBOBEE = { 
	GENERIC = "Hey, we've seen a similar statue somewhere...", 
	BEEINSIDE = "Shh, he's sleeping!" }

	
if GLOBAL.IsDLCEnabled(GLOBAL.CAPY_DLC) then

STRINGS.CHARACTERS.WALANI.DESCRIBE.ROBOBEE = "It's my own automated friend."
STRINGS.CHARACTERS.WARLY.DESCRIBE.ROBOBEE = "You gather - I'll cook!"
STRINGS.CHARACTERS.WOODLEGS.DESCRIBE.ROBOBEE = "Yer lookin' fer somethin'?"

STRINGS.CHARACTERS.WALANI.DESCRIBE.STATUEROBOBEE = { 
	GENERIC = "This is electrifyingly cool!", 
	BEEINSIDE = "Lemme know when you're refreshed." }
	
STRINGS.CHARACTERS.WARLY.DESCRIBE.STATUEROBOBEE = { 
	GENERIC = "This thing looks certainly... interesting.", 
	BEEINSIDE = "It's sleeping like a rock." }
	
STRINGS.CHARACTERS.WOODLEGS.DESCRIBE.STATUEROBOBEE = { 
	GENERIC = "'Tis a thunder flower.", 
	BEEINSIDE = "A weird bed ye got there, matey." }

STRINGS.CHARACTERS.WOODLEGS.DESCRIBE.STATUEROBOBEE_BLUEPRINT = "'Tis blueprint looks quite complex."
	
end

if GLOBAL.IsDLCEnabled(GLOBAL.PORKLAND_DLC) then

STRINGS.CHARACTERS.WARBUCKS.DESCRIBE.ROBOBEE = "That's a quite large bug!"
STRINGS.CHARACTERS.WILBA.DESCRIBE.ROBOBEE = "I WELCOMETH THOU, ADMIRABLE'ST BUG"
STRINGS.CHARACTERS.WORMWOOD.DESCRIBE.ROBOBEE = "Big Buzz Friend!"

STRINGS.CHARACTERS.WARBUCKS.DESCRIBE.STATUEROBOBEE = { 
	GENERIC = "Curious little contraption.", 
	BEEINSIDE = "It must take a short rest before it takes off again." }
	
STRINGS.CHARACTERS.WILBA.DESCRIBE.STATUEROBOBEE = { 
	GENERIC = "WILBA APPRECIATE'ST 'TIS COLOUR", 
	BEEINSIDE = "BUG LAY'DETH HEREFORE AFTERWORTH IS'T WORK" }
	
STRINGS.CHARACTERS.WORMWOOD.DESCRIBE.STATUEROBOBEE = { 
	GENERIC = "Happy Bed Flower!", 
	BEEINSIDE = "Friend takes all space on bed" }
	
STRINGS.CHARACTERS.WILBA.DESCRIBE.STATUEROBOBEE_BLUEPRINT = "'TIS PAPER LOOK'ETH COMPLICATE'TH"
STRINGS.CHARACTERS.WORMWOOD.DESCRIBE.STATUEROBOBEE_BLUEPRINT = "Complex building plans"

end