require "behaviours/wander"
require "behaviours/follow"
require "behaviours/faceentity"
require "behaviours/chaseandattack"
require "behaviours/runaway"
require "behaviours/doaction"
--require "behaviours/choptree"
require "behaviours/findlight"
require "behaviours/panic"
require "behaviours/chattynode"
require "behaviours/leash"

local function HammerCheck(inst)
	return inst and inst.target_statuerobobee ~= nil
end

local function HammerAction(inst)
	if HammerCheck(inst) then
		return BufferedAction(inst, inst.target_statuerobobee, ACTIONS.HAMMER)
	end
end

local PigGuardDestructorBrain = Class(Brain, function(self, inst)
    Brain._ctor(self, inst)
end)

function PigGuardDestructorBrain:OnStart()

    local root = 
        PriorityNode(
        {
			WhileNode(function() return HammerCheck(self.inst) end, "Hammering", 
				DoAction(self.inst, HammerAction, "hammer", true ))
        }, .5)
    
    self.bt = BT(self.inst, root)
    
end

return PigGuardDestructorBrain