local assets=
{
    Asset("ANIM", "anim/sparks_robobee.zip"),
}

local prefabs = 
{
    "sparks_fx"
}

local function fn(Sim)
	local inst = CreateEntity()
	inst.entity:AddTransform()
	inst.entity:AddAnimState()
    inst.entity:AddSoundEmitter()
    inst.entity:AddLight()
    inst.persists = false
    
    inst.AnimState:SetBank("sparks_robobee")
    inst.AnimState:SetBuild("sparks_robobee")
    inst.AnimState:PlayAnimation("sparks_" .. tostring(math.random(3)))
    inst.AnimState:SetBloomEffectHandle( "shaders/anim.ksh" )

    inst:AddTag("FX")
    
    inst.Light:Enable(true)
    inst.Light:SetRadius(1)
    inst.Light:SetFalloff(2)
    inst.Light:SetIntensity(0.2)
    
    local fx = SpawnPrefab("sparks_fx")
    fx.Transform:SetPosition(inst:GetPosition():Get())
    local i = .9

    local dt = 1/20
    local sound = true
    inst:DoPeriodicTask(dt, function() 
        inst.Light:SetIntensity(i)
        i =i - dt*2
        --r = r - dt*3
        if i <= 0 then
            inst:Remove()
        end
    end)

    return inst
end

return Prefab( "common/fx/sparks_robobee", fn, assets, prefabs) 

